import React from 'react';
import ReactDOM from 'react-dom';
import {arc} from 'd3';

const width = 960;
const height = 500;
const centerX = width / 2;
const centerY = height / 2;
const strokeWidth = 10;
const eyeSocketX = 120;
const eyeoffsetX = 120;
const eyeoffsetY = 50;
const faceRadius = 15;
const faceOffsetX = 140;
const faceOffsetY = 50;


const mouthArc = d3.arc()
    .innerRadius(40)
    .outerRadius(45)
    .startAngle(Math.PI - Math.PI*3 / 8)
    .endAngle(Math.PI + Math.PI*3 / 8);

const noseArc = d3.arc()
    .innerRadius(0)
    .outerRadius(35)
    .startAngle(Math.PI / 2)
    .endAngle(Math.PI *3/ 2);


const eyeArc = d3.arc()
    .innerRadius(20)
    .outerRadius(30)
    .startAngle(-Math.PI/2)
    .endAngle(Math.PI/2);

const earArc = d3.arc()
    .innerRadius(0)
    .outerRadius(75)
    .startAngle(-Math.PI/2)
    .endAngle(Math.PI/2);


const App = () =>(
  <svg width = {width}  height = {height}>
    <g transform={`translate(${centerX},${centerY})`}>
      <circle 
              r = {centerY - strokeWidth/2} 
              fill = "white"
              stroke = "black"
              stroke-width = {strokeWidth}
        />
      <circle 
        r = {faceRadius}
        cx = {faceOffsetX}
        cy = {faceOffsetY}
        fill = "#f1948a"
      	/>
      <circle 
        r = {faceRadius}
        cx = {-faceOffsetX}
        cy = {faceOffsetY}
        fill = "#f1948a"
      	/>
      <ellipse
        cx = {eyeSocketX}
      	rx = "40"
        ry = "80"
        transform = "rotate(-30  )"
      	/>
      
      <ellipse
        cx = {eyeSocketX}
      	rx = "40"
        ry = "80"
        transform = "rotate(-150  )"
      	/>
      <path 
        d = {eyeArc()}
        transform = "rotate(20)    translate(70,-85)"
        fill = "white"
        />
      <path 
        d = {eyeArc()}
        transform = "rotate(-20)    translate(-70,-85)"
        fill = "white"
        />
      <path d = {noseArc()} />
      <path 
        d = {mouthArc()} 
        transform = "translate(39,50)"/>
      <path 
        d = {mouthArc()} 
        transform = "translate(-39,50)"/>
      <path 
        d = {earArc()} 
        transform = "rotate(50) translate(0,-240)"/>
      <path 
        d = {earArc()} 
        transform = "rotate(-50) translate(0,-240)"/>
    </g>
	</svg>
);

const rootElement = document.getElementById('root');
ReactDOM.render(<App />, rootElement);